package de.fraunhofer.iem.kpiCalculator.adapter.cve

import de.fraunhofer.iem.kpiCalculator.model.adapter.VulnerabilityDto
import org.junit.jupiter.api.Test

class CveAdapterTest {

    @Test
    fun transformSingleVulnerabilityToKpi() {
        val adapter = CveAdapter
        // valid input
        val validKpi = adapter.transformDataToKpi(
            VulnerabilityDto(
                cveIdentifier = "not blank",
                packageName = "not blank",
                severity = 0.1
            )
        )
        assert(validKpi.isNotEmpty())
        assert(validKpi.first().score in (0..100))

        // invalid input
        val invalidKpis = CveAdapter.transformDataToKpi(
            listOf(
                VulnerabilityDto(
                    cveIdentifier = "not blank",
                    packageName = "",
                    severity = 0.1
                ),
                VulnerabilityDto(
                    cveIdentifier = "",
                    packageName = "not blank",
                    severity = 0.1
                ),
                VulnerabilityDto(
                    cveIdentifier = "not blank",
                    packageName = "not blank",
                    severity = -0.1
                ),
                VulnerabilityDto(
                    cveIdentifier = "not blank",
                    packageName = "not blank",
                    severity = 10.1
                )
            )
        )
        assert(invalidKpis.isEmpty())
    }
}
